Package org.springframework.scheduling.concurrent

# Class ScheduledExecutorFactoryBean

java.lang.Object
org.springframework.util.CustomizableThreadCreator
org.springframework.scheduling.concurrent.CustomizableThreadFactory
org.springframework.scheduling.concurrent.ExecutorConfigurationSupport
org.springframework.scheduling.concurrent.ScheduledExecutorFactoryBean

All Implemented Interfaces:
  `Serializable`, `ThreadFactory`, `EventListener`, `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanNameAware`, `org.springframework.beans.factory.DisposableBean`, `org.springframework.beans.factory.FactoryBean<ScheduledExecutorService>`, `org.springframework.beans.factory.InitializingBean`, `ApplicationContextAware`, `ApplicationListener<ContextClosedEvent>`, `Lifecycle`, `Phased`, `SmartLifecycle`

public class ScheduledExecutorFactoryBean extends ExecutorConfigurationSupport implements org.springframework.beans.factory.FactoryBean<ScheduledExecutorService>
`FactoryBean` that sets up a `ScheduledExecutorService` (by default: a `ScheduledThreadPoolExecutor`) and exposes it for bean references.

Allows for registration of `ScheduledExecutorTasks`, automatically starting the `ScheduledExecutorService` on initialization and canceling it on destruction of the context. In scenarios that only require static registration of tasks at startup, there is no need to access the `ScheduledExecutorService` instance itself in application code at all; `ScheduledExecutorFactoryBean` is then just being used for lifecycle integration.

For an alternative, you may set up a `ScheduledThreadPoolExecutor` instance directly using constructor injection, or use a factory method definition that points to the `Executors` class. This is strongly recommended in particular for common `@Bean` methods in configuration classes, where this `FactoryBean` variant would force you to return the `FactoryBean` type instead of `ScheduledExecutorService`.

Note that `ScheduledExecutorService` uses a `Runnable` instance that is shared between repeated executions, in contrast to Quartz which instantiates a new Job for each execution.

WARNING: `Runnables` submitted via a native `ScheduledExecutorService` are removed from the execution schedule once they throw an exception. If you would prefer to continue execution after such an exception, switch this FactoryBean's `"continueScheduledExecutionAfterException"` property to "true".

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  - `setPoolSize(int)`
  - `setRemoveOnCancelPolicy(boolean)`
  - `ExecutorConfigurationSupport.setThreadFactory(java.util.concurrent.ThreadFactory)`
  - `ScheduledExecutorTask`
  - `ScheduledExecutorService`
  - `ScheduledThreadPoolExecutor`
  - Serialized Form

## Field Summary

### Fields inherited from class org.springframework.scheduling.concurrent.ExecutorConfigurationSupport

`DEFAULT_PHASE, logger`

### Fields inherited from interface org.springframework.beans.factory.FactoryBean

`OBJECT_TYPE_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`ScheduledExecutorFactoryBean()`

## Method Summary

Modifier and Type
Method
Description
`protected ScheduledExecutorService`
`createExecutor(int poolSize, ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)`
Create a new `ScheduledExecutorService` instance.
`ScheduledExecutorService`
`getObject()`
`Class<? extends ScheduledExecutorService>`
`getObjectType()`
`protected Runnable`
`getRunnableToSchedule(ScheduledExecutorTask task)`
Determine the actual Runnable to schedule for the given task.
`protected ExecutorService`
`initializeExecutor(ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)`
Create the target `ExecutorService` instance.
`boolean`
`isSingleton()`
`protected void`
`registerTasks(ScheduledExecutorTask[] tasks, ScheduledExecutorService executor)`
Register the specified `ScheduledExecutorTasks` on the given `ScheduledExecutorService`.
`void`
`setContinueScheduledExecutionAfterException(boolean continueScheduledExecutionAfterException)`
Specify whether to continue the execution of a scheduled task after it threw an exception.
`void`
`setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)`
Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.
`void`
`setPoolSize(int poolSize)`
Set the ScheduledExecutorService's pool size.
`void`
`setRemoveOnCancelPolicy(boolean removeOnCancelPolicy)`
Set the remove-on-cancel mode on `ScheduledThreadPoolExecutor`.
`void`
`setScheduledExecutorTasks(ScheduledExecutorTask... scheduledExecutorTasks)`
Register a list of ScheduledExecutorTask objects with the ScheduledExecutorService that this FactoryBean creates.

### Methods inherited from class org.springframework.scheduling.concurrent.ExecutorConfigurationSupport

`afterExecute, afterPropertiesSet, beforeExecute, cancelRemainingTask, destroy, getPhase, initialize, initiateEarlyShutdown, initiateShutdown, isRunning, onApplicationEvent, setAcceptTasksAfterContextClose, setApplicationContext, setAwaitTerminationMillis, setAwaitTerminationSeconds, setBeanName, setPhase, setRejectedExecutionHandler, setThreadFactory, setThreadNamePrefix, setVirtualThreads, setWaitForTasksToCompleteOnShutdown, shutdown, start, stop, stop`

### Methods inherited from class org.springframework.scheduling.concurrent.CustomizableThreadFactory

`newThread`

### Methods inherited from class org.springframework.util.CustomizableThreadCreator

`createThread, getDefaultThreadNamePrefix, getThreadGroup, getThreadNamePrefix, getThreadPriority, isDaemon, nextThreadName, setDaemon, setThreadGroup, setThreadGroupName, setThreadPriority`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.springframework.context.ApplicationListener

`supportsAsyncExecution`

### Methods inherited from interface org.springframework.context.SmartLifecycle

`isAutoStartup`

## Constructor Details

### ScheduledExecutorFactoryBean

public ScheduledExecutorFactoryBean()

## Method Details

### setPoolSize

public void setPoolSize(int poolSize)
Set the ScheduledExecutorService's pool size. Default is 1.

### setScheduledExecutorTasks

public void setScheduledExecutorTasks(ScheduledExecutorTask... scheduledExecutorTasks)
Register a list of ScheduledExecutorTask objects with the ScheduledExecutorService that this FactoryBean creates. Depending on each ScheduledExecutorTask's settings, it will be registered via one of ScheduledExecutorService's schedule methods.

See Also:
  - `ScheduledExecutorService.schedule(java.lang.Runnable, long, java.util.concurrent.TimeUnit)`
  - `ScheduledExecutorService.scheduleWithFixedDelay(java.lang.Runnable, long, long, java.util.concurrent.TimeUnit)`
  - `ScheduledExecutorService.scheduleAtFixedRate(java.lang.Runnable, long, long, java.util.concurrent.TimeUnit)`

### setRemoveOnCancelPolicy

public void setRemoveOnCancelPolicy(boolean removeOnCancelPolicy)
Set the remove-on-cancel mode on `ScheduledThreadPoolExecutor`.

Default is `false`. If set to `true`, the target executor will be switched into remove-on-cancel mode (if possible, with a soft fallback otherwise).

### setContinueScheduledExecutionAfterException

public void setContinueScheduledExecutionAfterException(boolean continueScheduledExecutionAfterException)
Specify whether to continue the execution of a scheduled task after it threw an exception.

Default is "false", matching the native behavior of a `ScheduledExecutorService`. Switch this flag to "true" for exception-proof execution of each task, continuing scheduled execution as in the case of successful execution.

See Also:
  - `ScheduledExecutorService.scheduleAtFixedRate(java.lang.Runnable, long, long, java.util.concurrent.TimeUnit)`

### setExposeUnconfigurableExecutor

public void setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)
Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.

Default is "false", exposing the raw executor as bean reference. Switch this flag to "true" to strictly prevent clients from modifying the executor's configuration.

See Also:
  - `Executors.unconfigurableScheduledExecutorService(java.util.concurrent.ScheduledExecutorService)`

### initializeExecutor

protected ExecutorService initializeExecutor(ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)
Description copied from class: `ExecutorConfigurationSupport`
Create the target `ExecutorService` instance. Called by `afterPropertiesSet`.

Specified by:
  `initializeExecutor` in class `ExecutorConfigurationSupport`
Parameters:
  `threadFactory` - the ThreadFactory to use
  `rejectedExecutionHandler` - the RejectedExecutionHandler to use
Returns:
  a new ExecutorService instance
See Also:
  - `ExecutorConfigurationSupport.afterPropertiesSet()`

### createExecutor

protected ScheduledExecutorService createExecutor(int poolSize, ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)
Create a new `ScheduledExecutorService` instance.

The default implementation creates a `ScheduledThreadPoolExecutor`. Can be overridden in subclasses to provide custom `ScheduledExecutorService` instances.

Parameters:
  `poolSize` - the specified pool size
  `threadFactory` - the ThreadFactory to use
  `rejectedExecutionHandler` - the RejectedExecutionHandler to use
Returns:
  a new ScheduledExecutorService instance
See Also:
  - `ExecutorConfigurationSupport.afterPropertiesSet()`
  - `ScheduledThreadPoolExecutor`

### registerTasks

protected void registerTasks(ScheduledExecutorTask[] tasks, ScheduledExecutorService executor)
Register the specified `ScheduledExecutorTasks` on the given `ScheduledExecutorService`.

Parameters:
  `tasks` - the specified ScheduledExecutorTasks (never empty)
  `executor` - the ScheduledExecutorService to register the tasks on.

### getRunnableToSchedule

protected Runnable getRunnableToSchedule(ScheduledExecutorTask task)
Determine the actual Runnable to schedule for the given task.

Wraps the task's Runnable in a `DelegatingErrorHandlingRunnable` that will catch and log the Exception. If necessary, it will suppress the Exception according to the `"continueScheduledExecutionAfterException"` flag.

Parameters:
  `task` - the ScheduledExecutorTask to schedule
Returns:
  the actual Runnable to schedule (may be a decorator)

### getObject

@Nullable public ScheduledExecutorService getObject()

Specified by:
  `getObject` in interface `org.springframework.beans.factory.FactoryBean<ScheduledExecutorService>`

### getObjectType

public Class<? extends ScheduledExecutorService> getObjectType()

Specified by:
  `getObjectType` in interface `org.springframework.beans.factory.FactoryBean<ScheduledExecutorService>`

### isSingleton

public boolean isSingleton()

Specified by:
  `isSingleton` in interface `org.springframework.beans.factory.FactoryBean<ScheduledExecutorService>`